<?php

namespace Tygh\Addons\SchetmashCash;

use Tygh\Registry;
use Tygh\Addons\RusTaxes\ReceiptFactory;
use Tygh\Addons\RusTaxes\TaxType;
use Tygh\Addons\RusTaxes\Receipt\Item;
use Tygh\Addons\RusTaxes\Receipt\Receipt;
use Tygh\Settings;


class Schetmash {

    const SERVICE_URL = 'https://online.schetmash.com/lk/api/v1';
    const SERVICE_PORT = 443;
    

    private function send($_path = '', $_data = null)    {
		
		//$this->myLog($_data, 'отправка данных'); //Удалить!!!

        $curl = curl_init();
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_URL, static::SERVICE_URL.'/'.$_path);
        curl_setopt($curl, CURLOPT_PORT , static::SERVICE_PORT);         
        if(isset($_data)) { 
			curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'POST');
			curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($_data));  
		  }  
        curl_setopt($curl, CURLOPT_HEADER, false);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true); 
        curl_setopt($curl, CURLOPT_TIMEOUT, 30);

        $out = curl_exec($curl); 
        $code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $err = curl_error($curl);
		curl_close($curl); 


        if (!$code) { $this->myLog( $err, 'Сервер вернул ошибку!');  return false;  }  		     
		if ((int)$code !== 200) {  $this->myLog('Сервер вернул ошибку! Код ошибки: ' . $code);   return false;      }	
	
		//$this->myLog($out, 'ответ');  //Удалить!!!
        return json_decode( $out );		
    }
    

    private function printCheck($data, $operation)
	{	
        $receipt_factory = new ReceiptFactory( 'RUB', TaxType::getMap(), false );        
       
        $receipt = $receipt_factory->createReceiptFromOrder($data, 'RUB', false);
     
		$checkQuery = new \stdClass;
		$timestamp = new \DateTime();
		$timestamp->setTimestamp($data['timestamp']);
        $checkQuery->timestamp = $timestamp->format('d.m.Y H:i:s');
		$checkQuery->external_id = $operation . '_'. $_SERVER['HTTP_HOST'] . '_'.$data['order_id']; 
		$checkQuery->service = new \stdClass;
		//$checkQuery->service->inn = $config->getOption('inn');

		//$api_token = Registry::get('addons.rus_schetmash_cash.api_token');
		$api_token = Settings::instance()->getValue('api_token', 'rus_schetmash_cash');
		
        if(!empty($api_token)) { 
            $api_token = '&api_token='.$api_token;  
		} 
		
        $checkQuery->service->callback_url = fn_url('schetmash_cash.api'.$api_token, 'C');

		//$checkQuery->service->payment_address = $config->getOption('payment_address');
			
		$checkQuery->receipt = new \stdClass;
		$checkQuery->receipt->attributes = new \stdClass;
		$checkQuery->receipt->attributes->sno = Registry::get('addons.rus_schetmash_cash.sno');

        $email = $receipt->getEmail();
        $phone = $receipt->getPhone(); 
		if(isset($email) && !empty($email) ) { $checkQuery->receipt->attributes->email = $email; }
		if(isset($phone) && !empty($phone) ) { $checkQuery->receipt->attributes->phone = $phone; }
			
		$checkQuery->receipt->payments = array();
		$checkQuery->receipt->items = array();
		$checkQuery->receipt->total = $receipt->getTotal();
		

		//foreach ($data['payments'] as $payment)
		//{
			$checkQuery->receipt->payments[] = array(
				'type' => 1, 
				'sum' =>  $receipt->getTotal()
			);
        //}

        $receipt->allocateDiscountByUnit();
        $items = $receipt->getItems();

		foreach ($items as  $item)
		{
			$checkQuery->receipt->items[] = array(
				'name' => substr( $item->getName(), 0, 128),
				'price' => $this->formatFloat( $item->getPrice() ),
				'sum' => $this->formatFloat(  $item->getTotal() ),
				'quantity' => $this->formatFloat( $item->getQuantity(), 3),
                'tax' => $item->getTaxType(),
                'tax_sum' =>  $this->formatFloat(  $item->getTaxSum() ),  
			);
		}   
	

		//$token = Registry::get('addons.rus_schetmash_cash.token'); 
		$token = Settings::instance()->getValue('token', 'rus_schetmash_cash');
		$shopid = Registry::get('addons.rus_schetmash_cash.schetmash_group_code'); 


		if(empty($shopid) ) { 	return false; }

		$url = $shopid . '/' . $operation . '?token=';

		if (empty($token ))	{
			$token = $this->getToken();
			if (!$token ) {	return false;	}
        }      

		

		$result = $this->send($url.$token, $checkQuery); 	

		if(!is_object($result) ) { return false;  }

		if (isset($result->code) && ($result->code  ==  2 || $result->code == 4) )	{		
			$token = $this->getToken();
			if (!$token)	{	return false;	}


			$result = $this->send($url.$token, $checkQuery);
			if(!is_object($result) ) { return false;  }	
		}


		if (isset($result->id)  )	{
			return $result; 
		} 		

		return false;
    }
    

    private function formatFloat( $int, $count = 2){
		return	round( (float)$int , $count);
    }
    

    public function getStatusCheck($uuid) {

        $report = array('mess' => '', 'status' => false ); 
        
		//$token = Registry::get('addons.rus_schetmash_cash.token');
		$token = Settings::instance()->getValue('token', 'rus_schetmash_cash'); 
		$shopid = Registry::get('addons.rus_schetmash_cash.schetmash_group_code'); 

		if(empty($shopid) ) { $this->myLog('Нет shopid');
			return 'Нет shopid';
		}

		$url = $shopid . '/report/' . $uuid . '?token=';

		if (empty($token ))	{
			$token = $this->getToken();
			if (!$token ) {					 
				$report['mess'] = 'Не удалось получить токен';
				return $report;
			}
		}

		$result = $this->send($url.$token); 

		if(!is_object($result)  ) {
			$report['mess'] = 'Нет связи с сервером';
			 return $report; 
			}

		if (isset($result->code) && ($result->code  ==  2 || $result->code == 4) )	{	
			$token = $this->getToken();
			if (!$token)	{			
				$report['mess'] =  'Не удалось получить токен';
				return $report;
			}

			$result = $this->send($url.$token);
			if(!is_object($result) ) { 
				$report['mess'] = 'Нет связи с сервером';
				return $report; 
			  }	
		}

		if (isset($result->id)  )	{			 
			return $this->updateCheck($result);
		} 

		return $report; 
    }


    private function getToken()
	{

		$data = new \stdClass;
		$data->login = Registry::get('addons.rus_schetmash_cash.schetmash_login');  
		$data->password = Registry::get('addons.rus_schetmash_cash.schetmash_password');  		

		if(empty($data->login) || empty($data->password) ) { 
			return false; 
		}

		$result = $this->send('token',  $data);	
		
		if ( is_object($result) && isset($result->token) && !empty($result->token) )
		{
			//Registry::set('addons.rus_schetmash_cash.token', $result->token); 
			Settings::instance()->updateValue('token', $result->token, 'rus_schetmash_cash');
			return $result->token;
		} else {
			$this->myLog('Не удалось получить токен');
		}


		if ( is_object($result) && isset($result->code)  && $result->code == 1 ) { 
			$this->myLog('Неверный логин или пароль');
		}
		return false;
	}
    

    public function addCheck($order_id, $operation, $update = false) {
 	
		$orderData = fn_get_order_info($order_id);	

		if(isset($orderData) && !empty($orderData)) {
			$this->addCheck2($orderData, $operation, $update);
		}		
		
    }
    

    public function addCheck2($orderData, $operation,  $update = false)
    {        
        $report = array('mess' => '', 'status' => false ); 

        $curDate = date('Y-m-d H:i:s');	

		$result = $this->printCheck($orderData, $operation); 

        if($result === false || !is_object($result)) { 
			$result = new \stdClass;
			$result->status = 'no_conn';	
        }
        
        $data = array();
		$data['status'] = substr( (string)$result->status, 0, 20); 
		if(isset($result->id) ) { $data['uuid'] =  $result->id;  } 	


		if(!$update) { 
			$data['order_id'] = $orderData['order_id'];
			$data['data_create'] = $curDate; 
		}

		$data['sum'] =	$this->formatFloat( $orderData['total']); 
		$data['type'] = (string)$operation;
		$data['error'] = (!empty($result->error) ? json_encode($result->error) : '' ); 

		if(!$update) {
			$id = db_query("INSERT INTO `?:rus_schetmash_cash_receipts` ?e", $data);
		} else {
			$id = db_query('UPDATE `?:rus_schetmash_cash_receipts` SET ?u WHERE `id` = ?i', $data, $update);
		}
		if($id) {
			$report = array('mess' => 'Чек добавлен', 'status' => true ); 			
        }
        
        return $report; 

    }



	public function updateCheck($result) {	
		$report = array('mess' => 'Не удалось получить статус чека', 'status' => false ); 
		if(!is_object($result) || !isset($result->id) || !isset($result->status) || $result->status == 'accept' || $result->status == 'processing')   { return $report; } 		

		$data = array();
        $data['status'] = substr( (string)$result->status, 0, 20); 
        
		if(isset($result->timestamp) ) {
            $datetime = new \DateTime($result->timestamp);
            $data['data_print_end'] = $datetime->format('Y-m-d H:i:s');  
        }	
		if(!empty($result->error) ) { $data['error'] =  json_encode($result->error); } 
		if(!empty($result->payload) ) { $data['payload'] =  json_encode($result->payload); }		

        $id = db_query('UPDATE `?:rus_schetmash_cash_receipts` SET ?u WHERE `uuid` = ?i', $data, $result->id);
 
		if($id) {
			 $report = array('mess' => 'Статус чека изменён', 'status' => true ); 
		 } else {
			 $report['mess'] = 'Не удалось обновить чек';
			 $this->myLog('Не удалось обновить чек');
		 }

		return $report; 
	}




	public function deleteCheck($id) {
		db_query("DELETE FROM `?:rus_schetmash_cash_receipts` WHERE id = ?i ", $id); 
	}



	public function getProcessingCheck(){
		return db_get_row("SELECT `uuid`,`id`,`type`,`order_id` FROM `?:rus_schetmash_cash_receipts` WHERE `status` = 'processing' OR `status` = 'accept' OR `status` = 'no_conn' ORDER BY `data_create` ASC LIMIT 1");	
    }

    public function getCount($where = array()){
		if(empty($where)) { 
			return db_get_field("SELECT COUNT(*) FROM `?:rus_schetmash_cash_receipts` ");
		} else {
			return db_get_field("SELECT COUNT(*) FROM `?:rus_schetmash_cash_receipts`  WHERE ?w ", $where );
		}		
	}
	
	/*
	public function getHistoryOrder($order_id, $types) {
		$arr = array();
		foreach($types as $k => $v){
			$arr[] = $k;
		}
		return db_get_field("SELECT COUNT(*) FROM `?:order_data` WHERE `order_id` = ?i AND `type` IN (?s)", $order_id, $arr);
	}*/

	public function getHistoryOrder($order_id, $operation) {

		return db_get_field("SELECT COUNT(*) FROM `?:rus_schetmash_cash_receipts` WHERE `order_id` = ?i AND `type` = ?s ", $order_id, $operation);
	}


    

	public function getList($offset = 0, $countPage = 30, $where = array() ) {	

		if(!empty($where)) {
			$list = db_get_array("SELECT * FROM `?:rus_schetmash_cash_receipts` WHERE ?w ORDER BY `data_create` DESC LIMIT ?i , ?i ", $where, $offset, $countPage);
		} else {
			$list = db_get_array("SELECT * FROM `?:rus_schetmash_cash_receipts` ORDER BY `data_create` DESC LIMIT ?i , ?i ", $offset, $countPage);
		}		

		foreach($list as &$item){

			$item['link_params'] = '';		
            
			if(!empty($item['payload']) ) { 
				$item['link_params'] = $this->ofd1($item['payload'],  $item['type']); 
				$this->parse($item['payload']);			
			}
			if(!empty($item['error']) ) {  $this->parse($item['error']);  }

		}
		
		return $list; 		
    }
    

    private function parse(&$json)
	{
		$str = array();
		$arr = json_decode($json, true, 2);
		if(is_array($arr) ) {
			foreach($arr as $k => $v) {
				$str[] = __('rus_schetmash_cash.'.$k) . ': ' . $v;  
			}
			$json = $str;
		}
	
	}

	private function ofd1($payload, $type) {

		switch ($type) {
			case 'sell': $n = 1; break;
			case 'sell_refund': $n = 2; break;
			case 'buy': $n = 3; break;
			case 'buy_refund': $n = 4; break;			
			default: $n = '';	break;
		}

		$ob = json_decode($payload);
        $param = array();	

        $datetime = new \DateTime($ob->receipt_datetime);
        $param['t'] = $datetime->format('Ymd\THi');
		$param['s'] = $ob->total;
		$param['fn']= $ob->fn_number;
		$param['i'] = $ob->fiscal_document_number;
		$param['fp'] = $ob->fiscal_document_attribute;
		$param['n'] = $n; 

		return 'https://consumer.1-ofd.ru/v1?'.http_build_query($param);	
	}


	public function getLink($order_id, $type = 'sell'){

		$link = '';
		$row =  db_get_row("SELECT `payload`,`type` FROM `?:rus_schetmash_cash_receipts` WHERE `status` = 'success' AND `order_id` = ?i  AND `type` = ?s LIMIT 1", $order_id, $type);
		if(!empty($row['payload'])  && !empty($row['type'])) { 
			$link = $this->ofd1($row['payload'], $row['type']);
		}

		return $link; 
    }
    


    public function myLog($txt, $type = '') {
           
        file_put_contents( $_SERVER['DOCUMENT_ROOT'].'/var/schetmash.log', "\r\n [".date("Y-m-d H:i:s").'] '. (string)$type ."\r\n" .
        print_r($txt, true), FILE_APPEND);    
	}
	



}