<?php


use Tygh\Registry;
use Tygh\Settings;
use Tygh\Addons\SchetmashCash\Schetmash;

/**
 * Hook handler: after order status changed.
 *
 * @param string $status_to     Order status to
 * @param string $status_from   Order status from
 * @param array  $order_info    Order data
 */
function fn_rus_schetmash_cash_change_order_status($status_to, $status_from, $order_info)
{
    if ($order_info['is_parent_order'] === 'Y') {
        return;
    }

    $schetmash = Tygh::$app['addons.rus_schetmash_cash.schetmash'];    
    
    $statuses_paid = Registry::get('addons.rus_schetmash_cash.statuses_paid');    
    $statuses_refund = Registry::get('addons.rus_schetmash_cash.statuses_refund');   
    $payments = Registry::get('addons.rus_schetmash_cash.payments');   
    
    if( isset($statuses_paid[$status_to]) &&   
        !isset($statuses_paid[$status_from]) && 
        isset($payments[$order_info['payment_id']]) && 
        $schetmash->getHistoryOrder($order_info['order_id'], 'sell') == 0
    ) {        
        $schetmash->addCheck2($order_info, 'sell');      
    }


    if( isset($statuses_refund[$status_to]) && 
        !isset($statuses_refund[$status_from]) && 
        isset($payments[$order_info['payment_id']]) &&
        $schetmash->getHistoryOrder($order_info['order_id'], 'sell_refund') == 0
    ) {
        $schetmash->addCheck2($order_info, 'sell_refund');               
    }


} 

function fn_settings_actions_addons_rus_schetmash_cash() {
    
    if( function_exists( 'openssl_random_pseudo_bytes')) { 
        $bytes = openssl_random_pseudo_bytes(10);
        $api_token = bin2hex($bytes); 
        Settings::instance()->updateValue('api_token', $api_token, 'rus_schetmash_cash');
    }
  
}



